package xyz.ibatv.nethercraft.datagen;

import net.fabricmc.fabric.api.datagen.v1.FabricDataOutput;
import net.fabricmc.fabric.api.datagen.v1.provider.FabricRecipeProvider;
import net.fabricmc.fabric.api.tag.convention.v2.ConventionalItemTags;
import net.minecraft.data.server.recipe.RecipeExporter;
import net.minecraft.data.server.recipe.ShapedRecipeJsonBuilder;
import net.minecraft.recipe.book.RecipeCategory;
import net.minecraft.registry.RegistryWrapper;
import net.minecraft.registry.tag.ItemTags;
import net.minecraft.util.Identifier;
import xyz.ibatv.nethercraft.NethercraftClassic;
import xyz.ibatv.nethercraft.block.ModBlocks;
import xyz.ibatv.nethercraft.item.ModItems;

import java.util.concurrent.CompletableFuture;

public class ModRecipeProvider extends FabricRecipeProvider {
    public ModRecipeProvider(FabricDataOutput output, CompletableFuture<RegistryWrapper.WrapperLookup> registriesFuture) {
        super(output, registriesFuture);
    }

    @Override
    public void generate(RecipeExporter recipeExporter) {
        /*offerReversibleCompactingRecipes(recipeExporter, RecipeCategory.BUILDING_BLOCKS, ModItems.PROSPERITY_SHARD, RecipeCategory.BUILDING_BLOCKS, ModBlocks.PROSPERITY_GEMSTONE_BLOCK);
        offerReversibleCompactingRecipes(recipeExporter, RecipeCategory.BUILDING_BLOCKS, ModItems.PROSPERITY_INGOT, RecipeCategory.BUILDING_BLOCKS, ModBlocks.PROSPERITY_INGOT_BLOCK);


        ShapedRecipeJsonBuilder.create(RecipeCategory.MISC, ModItems.PROSPERITY_INGOT)
                .pattern(" S ")
                .pattern("SIS")
                .pattern(" S ")
                .input('S', ModItems.PROSPERITY_SHARD)
                .input('I', ConventionalItemTags.IRON_INGOTS)
                .criterion(hasItem(ModItems.PROSPERITY_SHARD), conditionsFromItem(ModItems.PROSPERITY_SHARD))
                .offerTo(recipeExporter, Identifier.of(MysticalAgricultureFabric.MOD_ID, "prosperity_shards_to_ingot"));


        ShapedRecipeJsonBuilder.create(RecipeCategory.MISC, ModItems.PRUDENTIUM_ESSENCE, 16)
                .pattern(" S ")
                .pattern("SIS")
                .pattern(" S ")
                .input('S', ModItems.INFERIUM_ESSENCE)
                .input('I', ModItems.INFUSION_CRYSTAL)
                .criterion(hasItem(ModItems.INFUSION_CRYSTAL), conditionsFromItem(ModItems.INFUSION_CRYSTAL))
                .offerTo(recipeExporter, Identifier.of(MysticalAgricultureFabric.MOD_ID, "prudentium_essence_recipe"));


        ShapedRecipeJsonBuilder.create(RecipeCategory.MISC, ModItems.PROSPERITY_SEED_BASE)
                .pattern(" S ")
                .pattern("SWS")
                .pattern(" S ")
                .input('S', ModItems.PROSPERITY_SHARD)
                .input('W', ModItems.PLACEHOLDER)
                //replace 'ModID:placeholder' with 'minecraft:wheat_seeds' after data gen
                .criterion(hasItem(ModItems.PROSPERITY_SHARD), conditionsFromItem(ModItems.PROSPERITY_SHARD))
                .offerTo(recipeExporter, Identifier.of(MysticalAgricultureFabric.MOD_ID, "prosperity_seed_base_recipe"));


        ShapedRecipeJsonBuilder.create(RecipeCategory.MISC, ModItems.INFERIUM_CROP_SEEDS)
                .pattern(" I ")
                .pattern("IBI")
                .pattern(" I ")
                .input('I', ModItems.INFERIUM_ESSENCE)
                .input('B', ModItems.PROSPERITY_SEED_BASE)
                .criterion(hasItem(ModItems.PROSPERITY_SEED_BASE), conditionsFromItem(ModItems.PROSPERITY_SEED_BASE))
                .offerTo(recipeExporter, Identifier.of(MysticalAgricultureFabric.MOD_ID, "t1_seed_base_recipe"));

        //
        // COAL ORE
        //

        ShapedRecipeJsonBuilder.create(RecipeCategory.MISC, ModItems.COAL_CROP_SEEDS)
                .pattern("CIC")
                .pattern("ITI")
                .pattern("CIC")
                .input('I', ModItems.PRUDENTIUM_ESSENCE)
                .input('T', ModItems.PROSPERITY_SEED_BASE)
                .input('C', ModItems.PLACEHOLDER)
                // Replace 'ModId:PLACEHOLDER' with 'minecraft:coal' after data gen
                .criterion(hasItem(ModItems.PROSPERITY_SEED_BASE), conditionsFromItem(ModItems.PROSPERITY_SEED_BASE))
                .offerTo(recipeExporter, Identifier.of(MysticalAgricultureFabric.MOD_ID, "coal_seeds_recipe"));

        ShapedRecipeJsonBuilder.create(RecipeCategory.MISC, ModItems.PLACEHOLDER, 12)
                // why the FUCK does coal not exist??? Most useless fucking thing possible.
                // Replace 'ModId:PLACEHOLDER' with 'minecraft:coal' after data gen
                .pattern("CCC")
                .pattern("C C")
                .pattern("CCC")
                .input('C', ModItems.COAL_ESSENCE)
                .criterion(hasItem(ModItems.COAL_ESSENCE), conditionsFromItem(ModItems.COAL_ESSENCE))
                .offerTo(recipeExporter, Identifier.of(MysticalAgricultureFabric.MOD_ID, "coal_essence_to_coal"));

        //
        // COPPER ORE
        //

        ShapedRecipeJsonBuilder.create(RecipeCategory.MISC, ModItems.COPPER_CROP_SEEDS)
                .pattern("CIC")
                .pattern("ITI")
                .pattern("CIC")
                .input('I', ModItems.INFERIUM_ESSENCE)
                .input('T', ModItems.PROSPERITY_SEED_BASE)
                .input('C', ConventionalItemTags.COPPER_INGOTS)
                .criterion(hasItem(ModItems.PROSPERITY_SEED_BASE), conditionsFromItem(ModItems.PROSPERITY_SEED_BASE))
                .offerTo(recipeExporter, Identifier.of(MysticalAgricultureFabric.MOD_ID, "copper_seeds_recipe"));

        ShapedRecipeJsonBuilder.create(RecipeCategory.MISC, ModItems.PLACEHOLDER, 12)
                // why the FUCK does copper ingot not exist??? Most useless fucking thing possible.
                // Replace 'ModId:PLACEHOLDER' with 'minecraft:copper_ingot' after data gen
                .pattern("CCC")
                .pattern("C C")
                .pattern("CCC")
                .input('C', ModItems.COPPER_ESSENCE)
                .criterion(hasItem(ModItems.COPPER_ESSENCE), conditionsFromItem(ModItems.COPPER_ESSENCE))
                .offerTo(recipeExporter, Identifier.of(MysticalAgricultureFabric.MOD_ID, "copper_essence_to_ingot"));

        //
        // IRON ORE
        //

        ShapedRecipeJsonBuilder.create(RecipeCategory.MISC, ModItems.IRON_CROP_SEEDS)
                .pattern("CIC")
                .pattern("ITI")
                .pattern("CIC")
                .input('I', ModItems.INFERIUM_ESSENCE)
                .input('T', ModItems.PROSPERITY_SEED_BASE)
                .input('C', ConventionalItemTags.IRON_INGOTS)
                .criterion(hasItem(ModItems.PROSPERITY_SEED_BASE), conditionsFromItem(ModItems.PROSPERITY_SEED_BASE))
                .offerTo(recipeExporter, Identifier.of(MysticalAgricultureFabric.MOD_ID, "iron_seeds_recipe"));

        ShapedRecipeJsonBuilder.create(RecipeCategory.MISC, ModItems.PLACEHOLDER, 12)
                // why the FUCK does iron ingot not exist??? Most useless fucking thing possible.
                // Replace 'ModId:PLACEHOLDER' with 'minecraft:iron_ingot' after data gen
                .pattern("CCC")
                .pattern("C C")
                .pattern("CCC")
                .input('C', ModItems.IRON_ESSENCE)
                .criterion(hasItem(ModItems.IRON_ESSENCE), conditionsFromItem(ModItems.IRON_ESSENCE))
                .offerTo(recipeExporter, Identifier.of(MysticalAgricultureFabric.MOD_ID, "iron_essence_to_ingot"));

        //
        // GOLD ORE
        //

        ShapedRecipeJsonBuilder.create(RecipeCategory.MISC, ModItems.GOLD_CROP_SEEDS)
                .pattern("CIC")
                .pattern("ITI")
                .pattern("CIC")
                .input('I', ModItems.INFERIUM_ESSENCE)
                .input('T', ModItems.PROSPERITY_SEED_BASE)
                .input('C', ConventionalItemTags.GOLD_INGOTS)
                .criterion(hasItem(ModItems.PROSPERITY_SEED_BASE), conditionsFromItem(ModItems.PROSPERITY_SEED_BASE))
                .offerTo(recipeExporter, Identifier.of(MysticalAgricultureFabric.MOD_ID, "gold_seeds_recipe"));

        ShapedRecipeJsonBuilder.create(RecipeCategory.MISC, ModItems.PLACEHOLDER, 12)
                // why the FUCK does gold ingot not exist??? Most useless fucking thing possible.
                // Replace 'ModId:PLACEHOLDER' with 'minecraft:gold_ingot' after data gen
                .pattern("CCC")
                .pattern("C C")
                .pattern("CCC")
                .input('C', ModItems.GOLD_ESSENCE)
                .criterion(hasItem(ModItems.GOLD_ESSENCE), conditionsFromItem(ModItems.GOLD_ESSENCE))
                .offerTo(recipeExporter, Identifier.of(MysticalAgricultureFabric.MOD_ID, "gold_essence_to_ingot"));

        //
        // DIAMOND ORE
        //

        ShapedRecipeJsonBuilder.create(RecipeCategory.MISC, ModItems.DIAMOND_CROP_SEEDS)
                .pattern("CIC")
                .pattern("ITI")
                .pattern("CIC")
                .input('I', ModItems.INFERIUM_ESSENCE)
                .input('T', ModItems.PROSPERITY_SEED_BASE)
                .input('C', ConventionalItemTags.DIAMOND_GEMS)
                .criterion(hasItem(ModItems.PROSPERITY_SEED_BASE), conditionsFromItem(ModItems.PROSPERITY_SEED_BASE))
                .offerTo(recipeExporter, Identifier.of(MysticalAgricultureFabric.MOD_ID, "diamond_seeds_recipe"));

        ShapedRecipeJsonBuilder.create(RecipeCategory.MISC, ModItems.PLACEHOLDER, 12)
                // why the FUCK does DIAMONDS not exist??? Most useless fucking thing possible.
                // Replace 'ModId:PLACEHOLDER' with 'minecraft:diamond' after data gen
                .pattern("CCC")
                .pattern("C C")
                .pattern("CCC")
                .input('C', ModItems.DIAMOND_ESSENCE)
                .criterion(hasItem(ModItems.DIAMOND_ESSENCE), conditionsFromItem(ModItems.DIAMOND_ESSENCE))
                .offerTo(recipeExporter, Identifier.of(MysticalAgricultureFabric.MOD_ID, "diamond_essence_to_gem"));*/
    }
}
